/****************************************************************************
  FILE: JEx41.java, TomaszMajor-02Feb99
  PURPOSE: Tango tutorial example
****************************************************************************/


import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;
import webwisdom.tango.*;


public class JEx41 extends Applet
  implements ActionListener, TDataListener, TControlListener
{
    private static final String CL="JEx41";


    TextField text;
    List list;
    Button button;
    TAgent agent=null;


    public JEx41()
    {
      text=new TextField();
      list=new List(4,true);
      button=new Button("debug");
      setLayout(new BorderLayout());
      add("North",text);
      add("Center",list);
      add("South",button);
      text.addActionListener(this);
      button.addActionListener(this);
    }// JEx ________________________________________________________________


    public void init()
    {
      try
      {
	agent=new TAgent(new TLAgentApplet(this));
	agent.addTDataListener(this);
	agent.addTControlListener(this);
	String[] pn=agent.getParticipantNames();
	for(int i=0;i<pn.length;i++)
	  list.add(pn[i]);
      }
      catch(TangoException e)
      {
	e.printStackTrace();
      }
    }// init _______________________________________________________________


    public void destroy()
    {
      if(agent!=null)
	agent.exit();
    }// destroy ____________________________________________________________


    public void actionPerformed(ActionEvent evt)
    {
      if(evt.getSource()==text)
      {
	if(agent!=null)
	  agent.selectiveSend(list.getSelectedItems(),
			      (text.getText()).getBytes());
      }
    }// actionPerformed ____________________________________________________


    public void receive(byte b[])
    {
      text.setText(new String(b));
    }// receive ____________________________________________________________


    public void masterChanged(boolean isMaster,String masterName)
    {
    }// masterChanged ______________________________________________________


    public void participantJoined(String name)
    {
      System.out.println(CL+".participantJoined("+name+")");
      list.add(name);
    }// participantJoined __________________________________________________


    public void participantLeft(String name)
    {
      System.out.println(CL+".participantLeft("+name+")");
      list.remove(name);
    }// participantLeft ____________________________________________________


    public void audioRequested(boolean r)
    {
    }// audioRequested _____________________________________________________


}// JEx ////////////////////////////////////////////////////////////////////


